from jinja2 import Environment, FileSystemLoader,Template
import smtplib
import email.utils
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText
from email.mime.base import MIMEBase
from email import encoders
from os.path import basename


def Mail(data):
    
    html = """
    <html>
    <style>
        table {
            border-collapse: collapse;
        }
        th, td {
            border: 1px solid black;
            padding: 8px;
        }
    </style>
    <body>
        <table>
          <tr>
            <th>System Name</th>
            <th>IP Address</th>
            <th>SID</th>
            <th>OS Type</th>
            <th>OS Version</th>
            <th>DB Type</th>
            <th>DB Version</th>
          </tr>

            <tr>
              <td>{{ data.sysname }}</td>
              <td>{{ data.ip }}</td>
              <td>{{ data.sid }}</td>
              <td>{{ data.ostype }}</td>
              <td>{{ data.osversion }}</td>
              <td>{{ data.dbtype }}</td>
              <td>{{ data.dbversion }}</td>
            </tr>
        </table>

        <br>
        <br>

        <table>
          <thead>
            <tr>
              <th>Instance Name</th>
              <th>Instance Number</th>
              <th>Monitoring Metric</th>
              <th>Status</th>
            </tr>
          </thead>
          <tbody>
            {% for item in data.alerts %}
              <tr>
                <td>{{ item[0] }}</td>
                <td>{{ item[1] }}</td>
                <td>{{ item[2] }}</td>
                <td>{{ item[3] }}</td>        
              </tr>
            {% endfor %}
          </tbody>
        </table>

    </body>
    </html>
    """
    template = Template(html)
    html_content = template.render(data = data)

    SENDER = 'care4sap@canopusgbs.com'  
    SENDERNAME = 'care4sap.com'
    USERNAME_SMTP = "care4sap@canopusgbs.com"
    PASSWORD_SMTP = "tzhjywshxjvqkdrg"
    HOST = "smtp.office365.com"
    PORT = 587
    subject = "Monitoring Alert"
    to_address = 'rakesh.reddy@canopusgbs.com'

    message = MIMEMultipart()
    message['From'] = SENDER
    message['To'] = to_address
    message['Subject'] = subject


    message.attach(MIMEText(html_content, 'html'))

    with smtplib.SMTP(HOST, PORT ) as server:
        server.starttls()
        server.login(USERNAME_SMTP, PASSWORD_SMTP)
        server.sendmail(SENDER, to_address, message.as_string())
        server.close()

    return "success"    
