from django.shortcuts import render
from django.http import HttpResponse, HttpResponseNotFound
from rest_framework.parsers import JSONParser 
import datetime
import bcrypt
# Create your views here.
from rest_framework import viewsets
from rest_framework import status
from rest_framework.decorators import api_view
from rest_framework.response import Response
from .serializers import *
from .models import *
from cryptography.fernet import Fernet
import uuid
from requests import Session
from requests.auth import HTTPBasicAuth  # or HTTPDigestAuth, or OAuth1, etc.
from zeep.transports import Transport
from zeep import Client
from pyrfc import Connection
import ibm_db

import json

@api_view(['GET', 'POST'])
def healthcheckdatatopandas(request):
	if request.method == 'GET':

		activelogsdata = Activelogs.objects.all()
		activelogs = ActivelogsSerializer(activelogsdata, many = True)

		bufferpooldata = Bufferpool.objects.all()
		bufferpool = BufferpoolSerializer(bufferpooldata, many = True)

		dbidata = DbInstances.objects.all()
		dbinstances = DbInstancesSerializer(dbidata, many = True)

		runstatsdata = Runstats.objects.all()
		runstats = RunstatsSerializer(runstatsdata, many = True)

		dblockdata = Dblocksnap.objects.all()
		dblock = DblocksnapSerializer(dblockdata, many = True)

		memorydata = Memorymetrics.objects.all()
		memory = MemorymetricsSerializer(memorydata, many = True)

		fsdata = Fsmetircs.objects.all()
		fs = FsmetircsSerializer(fsdata, many = True)

		workprocessdata = Workprocess.objects.all()
		workprocess = WorkprocessSerializer(workprocessdata, many = True)

		abaplogsdata = Abaplogs.objects.all()
		abaplogs = AbaplogsSerializer(abaplogsdata, many = True)

		licencedata = Licence.objects.all()
		licence = LicenceSerializer(licencedata, many = True)		

		sclientsdata = Systemclients.objects.all()
		sclients = SystemclientsSerializer(sclientsdata, many = True)

		instdata = Instancelist.objects.filter(system_id = '529ad7ee468a4550ad5e0540985c0568')
		inst = InstSerializer(instdata, many = True)

		cpu = [{
		"uid":1,
		"User": 0.91,
		"Sys": 0.23,
		"Iowait": 0.0,
		"Steal": 0.3,
		"Idle": 98.55,
		"Nice": 0.0
		}]

		os = [{
		"uid":1,
		"hostname" : 'canopuscare',
		"Kernel": 'Linux 4.12.14-122.37-default'
		}]



		output = {
		'activelogs':activelogs.data,
		'bufferpool':bufferpool.data,
		'dbinstances':dbinstances.data,
		'runstats':runstats.data,
		'dblock':dblock.data,
		'memory':memory.data,
		'fs':fs.data,
		'workprocess':workprocess.data,
		'abaplogs':abaplogs.data,
		'licence':licence.data,
		'sclients':sclients.data,
		'cpu' : cpu,
		'os' : os,
		'instances':inst.data
		}
		# for i in serializer.data:
		# 	tup = (i['metric'],i['value'])
		# 	l.append(tup)

		# for j in serializer1.data:
		# 	tup1 = (j['metric'],j['value'])	
		# 	l1.append(tup1)
		# df = pd.DataFrame(l,columns =['Metric','Value'])
		# df1 = pd.DataFrame(l1,columns =['Metric','Value'])
		# env = Environment(loader=FileSystemLoader('.'))
		# template = env.get_template("exp.html")
		# template_vars = {"logs": df.to_html()}
		# html_out = template.render(template_vars)
		# output = {"data":html_out}
		# HTML(string=html_out).write_pdf("report.pdf")

		return Response(output,status = status.HTTP_200_OK)
		



db = (
    "DRIVER=IBM DB2 ODBC DRIVER;" 
    "DATABASE=SOD;"
    "HOSTNAME=106.51.159.2;"
    "PORT=5912;"
    "PROTOCAL=TCPIP;"
    "UID=db2sod;"
    "PWD=care4canopus;")
conn = ibm_db.connect(db,"","")

wsdl0 = 'http://106.51.159.2:52313/?wsdl'
wsdl1 = 'http://106.51.159.2:52213/?wsdl'
session = Session() 
session.auth = HTTPBasicAuth('sodadm', 'care4canopus')

session.verify = False
transport = Transport(session=session)

client = Client(wsdl=wsdl0, transport=transport)
client1 = Client(wsdl=wsdl1, transport=transport)

def workprocess(system_id,customer_id,email):
	a = client.service.ABAPGetSystemWPTable()
	sysid = system_id
	cusid = customer_id
	created_at = datetime.datetime.now()
	sub_by = email
	log_id = uuid.uuid4()
	healthchechid = '9670762fee9f4d95b745559293b3f641'			
	for i in a:
		wpuniqueid = uuid.uuid4()
		Instance = i['Instance']
		No = i['No']
		Typ = i['Typ']
		Status = i['Status']
		Reason = i['Reason']
		Start = i['Start']
		Err = i['Err']
		Cpu = i['Cpu']
		Sem = i['Sem']
		Time = i['Time']
		Program = i['Program']
		Client = i['Client']
		User = i['User']
		Action = i['Action']
		Table = i['Table']
		wp = Workprocess(wpuniqueid = wpuniqueid.hex,customer_id = cusid,system_id = sysid,instance = Instance,no = No,typ = Typ,status = Status,reason = Reason,start = Start,err = Err,sem = Sem,cpu = Cpu,time = Time,program = Program,client = Client,user = User,action=Action,table = Table,created_at= created_at,sub_by=sub_by,log_id=log_id)
		wp.save()
	status = 1
	log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
	log.save()

def abaplogs(system_id,customer_id,email):
	a = client.service.ABAPReadSyslog()
	a1 = client1.service.ABAPReadSyslog()
	sysid = system_id
	cusid = customer_id
	created_at = datetime.datetime.now()
	sub_by = email
	log_id = uuid.uuid4()
	healthchechid = '9670762fee9f4d95b745559293b3f651'
	list_abaplogs = a[0:5] + a1[0:5]
	for i in list_abaplogs:
		aluniqueid = uuid.uuid4()
		Time = i['Time']
		Typ = i['Typ']
		Client = i['Client']
		User = i['User']
		Tcode = i['Tcode']
		MNo = i['MNo']
		Text = i['Text']
		Severity = i['Severity']
		al = Abaplogs(abaplogsuniqueid=aluniqueid.hex,customer_id= cusid,system_id=sysid,time = Time,typ= Typ,client=Client,user =User,tcode=Tcode,mno=MNo,text=Text,severity=Severity,created_at=created_at,sub_by=sub_by,log_id=log_id)
		al.save()
	status = 1
	log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
	log.save()		


def licence(system_id,customer_id,email):
	a = client.service.OSExecute(command = "/usr/sap/SOD/SYS/exe/uc/linuxx86_64/saplikey -show pf=/sapmnt/SOD/profile/DEFAULT.PFL",**{'async':0},timeout=30 )
	sysid = system_id
	cusid = customer_id
	created_at = datetime.datetime.now()
	sub_by = email
	log_id = uuid.uuid4()
	healthchechid = '9670762fee9f4d95b745559293b3f661'
	lkuniqueid1 = uuid.uuid4()
	lkuniqueid2 = uuid.uuid4()
	hardwarekey = (a['lines']['item'][17].split())[-1]
	softwareproduct = (a['lines']['item'][18].split())[-1]
	validityend = (a['lines']['item'][24].split())[-1]
	hardwarekey1 = (a['lines']['item'][31].split())[-1]
	softwareproduct1 = (a['lines']['item'][32].split())[-1]
	validityend1 = (a['lines']['item'][38].split())[-1]
	lk1 = Licence(licencesuniqueid=lkuniqueid1.hex,customer_id= cusid,system_id=sysid,hardwarekey = hardwarekey,softwareproduct= softwareproduct,validityend=validityend,created_at=created_at,sub_by=sub_by,log_id=log_id)

	lk2 = Licence(licencesuniqueid=lkuniqueid2.hex,customer_id= cusid,system_id=sysid,hardwarekey = hardwarekey1,softwareproduct= softwareproduct1,validityend=validityend1,created_at=created_at,sub_by=sub_by,log_id=log_id)
	lk1.save()
	lk2.save()
	status = 1
	log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
	log.save()	

def sysclient(system_id,customer_id,email):
	conn = Connection(user='sap*', passwd='care4canopus', ashost='192.168.0.181', sysnr='22', client='000')
	result = conn.call('RFC_READ_TABLE',QUERY_TABLE = "T000",DELIMITER=',')		
	sysid = system_id
	cusid = customer_id
	created_at = datetime.datetime.now()
	sub_by = email
	log_id = uuid.uuid4()
	healthchechid = '9670762fee9f4d95b745559293b3f671'
	for i in result['DATA']:
		uclientuniqueid = uuid.uuid4()
		clientno = i['WA'].split(",")[0]
		clientname = i['WA'].split(",")[1]
		location = i['WA'].split(",")[2]
		currency = i['WA'].split(",")[3]
		uc = Systemclients(clientuniqueid=uclientuniqueid.hex,customer_id= cusid,system_id=sysid,clientno = clientno,clientname= clientname,location=location,currency=currency,created_at=created_at,sub_by=sub_by,log_id=log_id)
		uc.save()
	status = 1
	log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
	log.save()	

def memhealthcheck(system_id,customer_id,email):
	a = client.service.OSExecute(command="/usr/bin/free -h",**{'async':0},timeout=30 )
	sysid = system_id
	cusid = customer_id
	memuniqueid = uuid.uuid4()
	swapuniqueid = uuid.uuid4()
	created_at = datetime.datetime.now()
	sub_by = email
	log_id = uuid.uuid4()
	healthchechid = '9670762fee9f4d95b745559293b3f621'
	k = (a['lines']['item'][1]).split()
	k1 = (a['lines']['item'][-1]).split()
	mem = Memorymetrics(memuniqueid=memuniqueid.hex,customer_id= cusid,system_id=sysid,memtype = k[0][0:-1],total= k[1],used=k[2],free =k[3],shared=k[4],cache=k[5],available=k[6],created_at=created_at,log_id=log_id)

	swap = Memorymetrics(memuniqueid=swapuniqueid.hex,customer_id= cusid,system_id=sysid,memtype = k1[0][0:-1],total= k1[1],used=k1[2],free =k1[3],shared='',cache='',available='',created_at=created_at)
	mem.save()
	swap.save()
	status = 1
	log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
	log.save()

def fshealthcheck(system_id,customer_id,email):
	a = client.service.OSExecute(command = "/usr/bin/df -h",**{'async':0},timeout=30 )
	sysid = system_id
	cusid = customer_id
	created_at = datetime.datetime.now()	
	sub_by = email
	log_id = uuid.uuid4()
	healthchechid = '9670762fee9f4d95b745559293b3f622'
	k = (a['lines']['item'])
	del k[0]
	for j in k:			
		fsuniqueid = uuid.uuid4()
		obj = j.split()
		fs = Fsmetircs(fsuniqueid=fsuniqueid.hex,customer_id= cusid,system_id=sysid,filesys = obj[0],size= obj[1],used=obj[2],available =obj[3],perc=obj[4],mounted_on=obj[5],created_at=created_at,log_id=log_id)
		fs.save()	
	status = 1
	log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
	log.save()		



def db_instance_details(system_id,customer_id,email):
    stmt = ibm_db.exec_immediate(conn,"SELECT DISTINCT INSTNAME AS INST, HOST AS HOST, APSERVER AS APS, OPSYS AS OPS from SAPSOD.TPFID ORDER BY OPSYS")
    metrics = ['Instname','Host','APSERVER','OS']
    log_id = uuid.uuid4()
    created_at = datetime.datetime.now()
    sub_by = email
    sysid = system_id
    cusid = customer_id
    healthchechid = '9670762fee9f4d95b745559293b3f645'
    while ibm_db.fetch_row(stmt)!= False:
    	for i in range(4):
    		
	    	dbuniqid = uuid.uuid4()
	    	value = ibm_db.result(stmt,i)
	    	metric = metrics[i]
	    	
	    	inst = DbInstances(dbiuniqueid=dbuniqid.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
	    	
	    	inst.save()
	    	
    status = 1
    log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
    log.save()


def bufferpool(system_id,customer_id,email):
    stmt = ibm_db.exec_immediate(conn,"SELECT  SUBSTR(BP_NAME,1,14), TOTAL_HIT_RATIO_PERCENT,  DATA_HIT_RATIO_PERCENT,  INDEX_HIT_RATIO_PERCENT FROM SYSIBMADM.BP_HITRATIO where TOTAL_HIT_RATIO_PERCENT is not null")
    metrics = ['bpname','totalhrp','datahrp','indexhrp']
    log_id = uuid.uuid4()
    created_at = datetime.datetime.now()
    sub_by = email
    sysid = system_id
    cusid = customer_id
    healthchechid = '9670762fee9f4d95b745559293b3f623'
    while ibm_db.fetch_row(stmt)!= False:
    	for i in range(4):
    		
	    	bpuniqid = uuid.uuid4()
	    	value = ibm_db.result(stmt,i)
	    	metric = metrics[i]
	    	
	    	inst = Bufferpool(bpuniqueid=bpuniqid.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
	    	
	    	inst.save()
	    	
    status = 1
    log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
    log.save()  

def runstats(system_id,customer_id,email):
    stmt = ibm_db.exec_immediate(conn,"select substr(tabschema,1,10) as Schema, count(*) as count  from syscat.tables where days(current date) - days(stats_time) > 15 and type='T' group by tabschema order by count")
    
    log_id = uuid.uuid4()
    created_at = datetime.datetime.now()
    sub_by = email
    sysid = system_id
    cusid = customer_id
    healthchechid = '9670762fee9f4d95b745559293b3f689'
    while ibm_db.fetch_row(stmt)!= False:

    		
	    	rsuniqueid = uuid.uuid4()
	    	metric = ibm_db.result(stmt,0)
	    	value = ibm_db.result(stmt,1)
	    	
	    	inst = Runstats(rsuniqueid=rsuniqueid.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
	    	
	    	inst.save()
	    	
    status = 1
    log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
    log.save()


def Lockwaits(system_id,customer_id,email):
    stmt = ibm_db.exec_immediate(conn,"SELECT (char(count(*))) FROM SYSIBMADM.SNAPLOCKwait")
    stmt1 = ibm_db.exec_immediate(conn,"SELECT (char(count(*))) FROM SYSIBMADM.SNAPLOCK")
    log_id = uuid.uuid4()
    created_at = datetime.datetime.now()
    sub_by = email
    sysid = system_id
    cusid = customer_id
    healthchechid = '9670762fee9f4d95b745559293b3f667'    
    while ibm_db.fetch_row(stmt)!= False:
    	dbuniqid = uuid.uuid4()
    	metric = 'Locks Wait'
    	value = ibm_db.result(stmt,0)
    	lock = Dblocksnap(dblockuniqueid=dbuniqid.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
    	lock.save()

    while ibm_db.fetch_row(stmt1)!= False:
    	dbuniqid1 = uuid.uuid4()
    	metric = 'Locks Held'
    	value = ibm_db.result(stmt1,0)
    	lock = Dblocksnap(dblockuniqueid=dbuniqid1.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
    	lock.save()
    status = 1
    log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
    log.save()


def activelogs(system_id,customer_id,email):
    stmt = ibm_db.exec_immediate(conn,"SELECT substr(VALUE,1,10) FROM SYSIBMADM.DBCFG WHERE NAME LIKE '%logprimary%'")
    stmt1 = ibm_db.exec_immediate(conn,"SELECT substr(VALUE,1,10) FROM SYSIBMADM.DBCFG WHERE NAME LIKE '%logsecond%'")
    stmt2 = ibm_db.exec_immediate(conn,"SELECT  ltrim(char(SEC_LOGS_ALLOCATED))  FROM SYSIBMADM.SNAPDB")
    stmt3 = ibm_db.exec_immediate(conn,"SELECT ltrim(rtrim(char(value)))  FROM SYSIBMADM.DBCFG where name='logfilsiz'")
    stmt4 = ibm_db.exec_immediate(conn,"SELECT  ltrim(char(total_log_available))  FROM SYSIBMADM.SNAPDB")
    stmt5 = ibm_db.exec_immediate(conn,"SELECT  ltrim(char(total_log_used))  FROM SYSIBMADM.SNAPDB")
    stmt6 = ibm_db.exec_immediate(conn,"SELECT ltrim(char(log_to_redo_for_recovery))  FROM SYSIBMADM.SNAPDB")
    log_id = uuid.uuid4()
    created_at = datetime.datetime.now()
    sub_by = email
    sysid = system_id
    cusid = customer_id
    healthchechid = '9670762fee9f4d95b745559293b3f612'    
    while ibm_db.fetch_row(stmt)!= False:
    	al1uniqid = uuid.uuid4()
    	metric = 'Log Primary'
    	value = ibm_db.result(stmt,0)
    	alog = Activelogs(alogsuniqueid=al1uniqid.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
    	alog.save()

    while ibm_db.fetch_row(stmt1)!= False:
    	al1uniqid1 = uuid.uuid4()
    	metric = 'Log secondary'
    	value = ibm_db.result(stmt1,0)
    	alog = Activelogs(alogsuniqueid=al1uniqid1.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
    	alog.save()

    while ibm_db.fetch_row(stmt2)!= False:
    	al1uniqid2 = uuid.uuid4()
    	metric = 'Secondary Logs Allocated'
    	value = ibm_db.result(stmt2,0)
    	alog = Activelogs(alogsuniqueid=al1uniqid2.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
    	alog.save()

    while ibm_db.fetch_row(stmt3)!= False:
    	al1uniqid3 = uuid.uuid4()
    	metric = 'Log File Size'
    	value = ibm_db.result(stmt3,0)
    	alog = Activelogs(alogsuniqueid=al1uniqid3.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
    	alog.save()

    while ibm_db.fetch_row(stmt4)!= False:
    	al1uniqid4 = uuid.uuid4()
    	metric = 'LOG_SPACE_AVAILABLE'
    	value = ibm_db.result(stmt4,0)
    	alog = Activelogs(alogsuniqueid=al1uniqid4.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
    	alog.save()

    while ibm_db.fetch_row(stmt5)!= False:
    	al1uniqid5 = uuid.uuid4()
    	metric = 'LOG_SPACE_USED'
    	value = ibm_db.result(stmt5,0)
    	alog = Activelogs(alogsuniqueid=al1uniqid5.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
    	alog.save()

    while ibm_db.fetch_row(stmt6)!= False:
    	al1uniqid6 = uuid.uuid4()
    	metric = 'Log Recovery'
    	value = ibm_db.result(stmt6,0)
    	alog = Activelogs(alogsuniqueid=al1uniqid6.hex,customer_id= cusid,system_id=sysid,metric = metric,value= value,created_at=created_at,sub_by=sub_by,log_id = log_id)
    	alog.save()
    status = 1
    log = Healthchecklogs(healthchecklogsuniqueid=log_id,customer_id= cusid,system_id=sysid,healthcheck_id = healthchechid,starttime = created_at,created_at=created_at,run_by=sub_by,status = status)	    	
    log.save()



@api_view(['GET', 'POST'])
def runhealthcheck(request):
	if request.method == 'POST':
		cusid=request.data.get('cid')
		sysid=request.data.get('sid')
		email=request.data.get('run_by')

		# db_instance_details(sysid,cusid,email)

		# bufferpool(sysid,cusid,email)

		# runstats(sysid,cusid,email)

		# Lockwaits(sysid,cusid,email)

		# activelogs(sysid,cusid,email)

		# memhealthcheck(sysid,cusid,email)

		# fshealthcheck(sysid,cusid,email)

		# workprocess(sysid,cusid,email)

		# abaplogs(sysid,cusid,email)

		# licence(sysid,cusid,email)

		# sysclient(sysid,cusid,email)

		return Response({'output':'Success'}, status=status.HTTP_200_OK)

key = b'pRmgMa8T0INjEAfksaq2aafzoZXEuwKI7wDe4c1F8AY='

def check_sys_connectivity(uid,pwd):
	session = Session()
	session.auth = HTTPBasicAuth(uid,pwd)
	session.verify = False
	transport = Transport(session=session)
	client = Client(wsdl=wsdl, transport=transport)
	out_alert_tree = client.service.GetAlertTree()
	if len(out_alert_tree)>0:
		a = client.service.GetProcessList()
		if a[0]['textstatus'] == 'Running':
			status = 1
		elif a[0]['textstatus'] == 'Stopped':	
			status = 2
		else:
			status = 0	
	else:
		status = 'Not able to Connect'
	return status	

@api_view(['GET','POST'])
def dashboardmetricscount(request):
	if request.method == 'POST':
		cusid=request.data.get('cid')
		systemcount = SystemsNew.objects.filter(customer_id = cusid).exclude(status = 3)
		instcount = Instancelist.objects.filter(customer_id = cusid).exclude(status = 3)
		sol = SystemsNew.objects.filter(customer_id = cusid).exclude(status = 3).values('solution_id')
		serializer = SystemsnewSerializer(systemcount, many = True)
		up = 0
		down = 0
		partiallyup = 0
		temp =[]
		for i in sol:
			temp.append(i['solution_id'])
		for i in serializer.data:
			if i['status'] == '1':
				up = up + 1
			elif i['status'] == '2':
				down = down + 1
			else:
				partiallyup = partiallyup + 1	
		output = {'syscount' : len(systemcount),'instcount' : len(instcount) + len(systemcount),'solutioncount':len(set(temp)),'up':up,'down':down,'partiallyup':partiallyup }
		return Response(output,status = status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"},status = status.HTTP_400_BAD_REQUEST)

@api_view(['GET','POST'])
def CustomerList(request):
	if request.method == 'GET':
		CustDetails = CustomerMang.objects.all()
		serializer = CustomerMangSerializer(CustDetails, many = True)
		return Response(serializer.data,status = status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"},status = status.HTTP_400_BAD_REQUEST)	

@api_view(['GET', 'POST'])
def GetSystems(request):
	if request.method == 'POST':
		uniqueId=request.data.get('id')

		SystemDetails = Systems.objects.filter(customer_id = uniqueId)
		serializer = SystemsSerializer(SystemDetails, many = True)
		if (len(serializer.data)>0):
			return Response(serializer.data, status=status.HTTP_200_OK)
		else:
			return Response({"message" : "Either Customer Id is Wrong or No Systems under the Customer"}, status=status.HTTP_404_NOT_FOUND)	
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)	


@api_view(['GET', 'POST'])
def GetSystemsnew(request):
	if request.method == 'POST':
		uniqueId=request.data.get('id')

		SystemDetails = SystemsNew.objects.filter(customer_id = uniqueId).exclude(status =3)
		serializer = SystemsnewSerializer(SystemDetails, many = True)
		if (len(serializer.data)>0):
			return Response(serializer.data, status=status.HTTP_200_OK)
		else:
			return Response({"message" : "Either Customer Id is Wrong or No Systems under the Customer"}, status=status.HTTP_404_NOT_FOUND)	
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)

@api_view(['GET', 'POST'])
def GetSystemsbyId(request):
        if request.method == 'POST':
                customerId = request.data.get('cid')
                systemId = request.data.get('sid')


                SystemDetailsId = SystemsNew.objects.filter(customer_id = customerId).filter(sysuniqueid = systemId).exclude(status = 3)
                solid = SystemsNew.objects.filter(customer_id = customerId).filter(sysuniqueid = systemId).values('solution_id')[0]['solution_id']
                serializer = SystemsIdSerializer(SystemDetailsId, many = True)

                serializer.data[0]['solname'] = solutionname(solid)
                return Response(serializer.data, status=status.HTTP_200_OK)
        else:
        	return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)	       


@api_view(['GET', 'POST'])
def Getinstinfo(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Dbappinstancelist.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DbInstSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Gettreedata(request):
	if request.method == 'POST':
		systemId = request.data.get('sid')
		print(systemId)
		metrics = Alerttree.objects.filter(system_id = systemId)

		serializer = TreeSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetCPU(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Cpumetrics.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = CPUSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetSla(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')


		metrics = Sla.objects.filter(customer_id = customerId)

		serializer = SlaSerializer(metrics, many = True)
		mdown = 0
		mup = 0
		# today = datetime.today()
		# yesterday = today - timedelta(days = 1)
		up = 0
		down = 0
		for i in serializer.data:
			stime = datetime.datetime.strptime(i['stime'],"%d.%m.%Y %H:%M:%S")
			etime = datetime.datetime.strptime(i['etime'],"%d.%m.%Y %H:%M:%S")
			time_delta = (etime - stime)
			total_seconds = time_delta.total_seconds()
			minutes = total_seconds/3600

			if i['slastatus'] == 'Unavailable':
				mdown = mdown + minutes
			else :
				mup = mup + minutes

			# if stime>yesterday:
			# 	if i['slastatus'] == 'Unavailable':
			# 		down = down + minutes	
			# 	else:
			# 		up = up + minutes	
		output = {'mdown':mdown,'mup':mup,'wdown':mdown,'wup':mup,'up':24,'down':0}			

		return Response(output, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetFS(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')

		metrics = Fsmetircs.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = FSSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetMem(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Memorymetrics.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = MemSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetProcess(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		instanceId = request.data.get('iid')
		metrics = ProcessList.objects.filter(customer_id = customerId).filter(instance_id = instanceId)

		serializer = ProcessSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def SolutionList(request):
	if request.method == 'POST':
		cusid = request.data.get('cid')
		solutionlist = SystemsNew.objects.filter(customer_id = cusid).exclude(status =3).values('solution_id').distinct()

		serializer = SolutionlistSerializer(solutionlist, many = True)
		for i in serializer.data:
			i['solname'] = solutionname(i['solution_id'])
		
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetInst(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')
		ip = SystemsNew.objects.filter(customer_id = customerId).filter(sysuniqueid = systemId).values('ip')[0]['ip']
		systemname = SystemsNew.objects.filter(customer_id = customerId).filter(sysuniqueid = systemId).values('sysname')[0]['sysname']
		metrics = Instancelist.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = InstSerializer(metrics, many = True)
		for i in serializer.data:
			i['sname'] = systemname
			i['ip'] = ip		
		return Response(serializer.data, status=status.HTTP_200_OK)								

@api_view(['GET', 'POST'])
def GetInstAll(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		
		metrics = Instancelist.objects.filter(customer_id = customerId).exclude(status =3)

		serializer = InstSerializer(metrics, many = True)
		for i in serializer.data:
			ip = SystemsNew.objects.filter(customer_id = customerId).filter(sysuniqueid = i['system_id']).values('ip')[0]['ip']
			systemname = SystemsNew.objects.filter(customer_id = customerId).filter(sysuniqueid = i['system_id']).values('sysname')[0]['sysname']

			i['sname'] = systemname
			i['ip'] = ip
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetBuffer(request):
	if request.method == 'POST':
		
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')

		metrics = Buffer.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = BufferSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetDumps(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')

		metrics = Dumps.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DumpsSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Getusers(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')

		metrics = Usermanagement.objects.filter(customer_id = customerId).exclude(status =3)

		serializer = UsermanagementSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Getroles(request):
	if request.method == 'POST':
		metrics = Rolemang.objects.all()

		serializer = RolemangSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)


@api_view(['GET', 'POST'])
def Addusers(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		sub_by = request.data.get('sub_by')
		email = request.data.get('email')
		fname = request.data.get('fname')
		lname = request.data.get('lname')
		# roles = request.data.get('roles')
		pwd = request.data.get('pwd')
		hashAndSalt = bcrypt.hashpw(pwd.encode(), bcrypt.gensalt()) 
		fpwd = hashAndSalt.decode('utf8')
		mob = request.data.get('mob')
		role_id = request.data.get('role_id')
		created_at = datetime.datetime.now()
		modified_at = datetime.datetime.now()
		isverified = 1
		user_status = 1	
		useruniqueid = uuid.uuid4()	
		obj = Rolemang.objects.get(roleuniqueid=role_id)
		rolename = obj.rolename
		user = Usermanagement(useruniqueid = useruniqueid.hex,customer_id = customerId,fname = fname,lname=lname,email = email,password = fpwd,role=rolename,isverified=isverified,status=user_status,sub_by=sub_by,created_at = created_at,modified_at = modified_at,mobilenum = mob,role_id = role_id)	
		user.save()
		return Response({'result':'User Added'}, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def Delusers(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		userId = request.data.get('uid')
		user = Usermanagement.objects.get(useruniqueid = userId)
		
		# user.values('status')[0]['status'] = 3
		user.status = 3
		user.save()
		return Response({'result':'User Deleted'}, status=status.HTTP_200_OK)

@api_view(['POST'])
def Delsystems(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		system = SystemsNew.objects.get(sysuniqueid = systemId)
		
		system.status = 3
		system.save()

		instances = Instancelist.objects.filter(customer_id = customerId).filter(system_id = systemId).update(status = 3)


		return Response({'result':instances}, status=status.HTTP_200_OK)


@api_view(['GET', 'POST'])
def GetSpool(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')

		metrics = Spool.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = SpoolSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)

@api_view(['GET', 'POST'])
def GetResponsetimes(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')

		metrics = Responsetimes.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = ResponseSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)						


@api_view(['GET', 'POST'])
def GetSol(request):
	if request.method == 'POST':
		customerId = request.data.get('id')
		

		metrics = Sapsolution.objects.filter(customer_id = customerId)

		serializer = SolSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)	
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)							

@api_view(['GET', 'POST'])
def Getsysbysolid(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		solutionId = request.data.get('solutionid')
		

		metrics = SystemsNew.objects.filter(customer_id = customerId).filter(solution_id = solutionId).exclude(status = 3)

		serializer = SystemsnewSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)

def solutionname(id):
	name = Sapsolution.objects.filter(soluniqueid = id).values('solname')[0]['solname']
	return name
# def instancelistsingle(ip,sid,pwd,sysid,cusid,wsd):
# 	instsession = Session()
# 	instsession.auth = HTTPBasicAuth(sid,pwd)
# 	instsession.verify = True
# 	transport = Transport(session=instsession)
# 	instclient = Client(wsdl=wsd, transport=transport)

# 	a = instclient.service.GetSystemInstanceList()
# 	for j in a:
# 		sysname = j['hostname']
# 		instanceno = j['instanceNr']
# 		http_port = j['httpPort']
# 		https_port = j['httpsPort']
# 		start_priority = j['startPriority']
# 		features = j['features']
# 		status = j['dispstatus']
# 		wsdl ='http://' + ip + ':' + str(http_port) + '/?wsdl'
# 		created_at = datetime.now()
# 		insuniqueid = uuid.uuid4()
# 		modified_at = datetime.now()
# 		instancename = sysname + '_' + str(instanceno)
# 		insc = Instancelist(insuniqueid = insuniqueid.hex,system_id = sysid,customer_id = cusid,sysname = sysname,instanceno=instanceno,http_port = http_port,https_port = https_port,start_priority=start_priority,instancewsdlurl=wsdl,features=features,status=status,created_at = created_at,modified_at = modified_at,instaname = instancename)	
# 		insc.save()
# 		processlistsingle(wsdl,sid,pwd,sysid,cusid,insuniqueid.hex)	

def instancelistsingle(ip,sid,pwd,sysid,cusid,wsd):
        instsession = Session()
        instsession.auth = HTTPBasicAuth(sid,pwd)
        instsession.verify = True
        transport = Transport(session=instsession)
        instclient = Client(wsdl=wsd, transport=transport)

        a = instclient.service.GetSystemInstanceList()
        for j in a:
                sysname = j['hostname']
                instanceno = j['instanceNr']
                http_port = j['httpPort']
                https_port = j['httpsPort']
                start_priority = j['startPriority']
                features = j['features']
                status = j['dispstatus']
                if status == "SAPControl-GREEN":
                        insstatus = 1
                elif status == "SAPControl-YELLOw":
                        insstatus = 2
                else:
                        insstatus = 0
                wsdl ='http://' + ip + ':' + str(http_port) + '/?wsdl'
                created_at = datetime.datetime.now()
                insuniqueid = uuid.uuid4()
                modified_at = datetime.datetime.now()
                instancename = sysname + '_' + str(instanceno)
                insc = Instancelist(insuniqueid = insuniqueid.hex,system_id = sysid,customer_id = cusid,sysname = sysname,instanceno=instanceno,http_port = http_port,https_port = https_port,start_priority=start_priority,instancewsdlurl=wsdl,features=features,status=insstatus,created_at = created_at,modified_at = modified_at,instaname = instancename)
                insc.save()
                processlistsingle(wsdl,sid,pwd,sysid,cusid,insuniqueid.hex) 

def processlistsingle(wsdl,sid,pwd,sysid,cusid,iid):
	processsession = Session()
	processsession.auth = HTTPBasicAuth(sid,pwd)
	processsession.verify = True
	transport = Transport(session=processsession)
	processclient = Client(wsdl=wsdl, transport=transport)
	a = processclient.service.GetProcessList()
	for j in a:
		name = j['name']
		description = j['description']
		dispstatus = j['dispstatus']
		starttime = j['starttime']
		if starttime is None:
			time=0
		else:	
			k = starttime.split()
			l1 = k[0:-1]
			s = '-'
			s = s.join(l1)
			time = s + ' ' + k[-1]
		
		created_at = datetime.datetime.now()
		processuniqueid = uuid.uuid4()	
		process = ProcessList(processuniqueid = processuniqueid.hex,system_id = sysid,customer_id = cusid,pname = name,pdesc=description,dispstatus = dispstatus,stime = time,created_at = created_at,instance_id =iid)	
		process.save()
# def slasingle(wsdl,sid,pwd,sysid,cusid):
# 	slasession = Session()
# 	treesession.auth = HTTPBasicAuth(sid,pwd)
# 	treesession.verify = True
# 	transport = Transport(session=treesession)
# 	treeclient = Client(wsdl=wsdl, transport=transport)
# 	a = treeclient.service.GetProcessList()


def currentalerts(wsdl,sid,pwd,sysid,cusid):
	treesession = Session()
	treesession.auth = HTTPBasicAuth(sid,pwd)
	treesession.verify = True
	transport = Transport(session=treesession)
	treeclient = Client(wsdl=wsdl, transport=transport)
	a = treeclient.service.GetAlertTree()
	for i in a:
		if i['parent'] ==-1:
			i['parent'] = ""
		
		if i['name'] == None:
			i['name'] = "None"

		if i['parent'] == None:
			i['parent'] = "None"

		if i['ActualValue'] == None:
			i['ActualValue'] = "None"

		if i['description'] == None:
			i['description'] = "None"

		if i['Time'] == None:
			i['Time'] = "None"

		if i['AnalyseTool'] == None:
			i['AnalyseTool'] = "None"

		if i['VisibleLevel'] == None:
			i['VisibleLevel'] = "None"

		if i['HighAlertValue'] == None:
			i['HighAlertValue'] = "None"

		if i['AlDescription'] == None:
			i['AlDescription'] = "None"

		if i['AlTime'] == None:
			i['AlTime'] = "None"

		if i['Tid'] == None:
			i['Tid'] = "None"

	new_a = []
	dictionary = {}
	for i in a:
		dictionary = {}
		dictionary['name'] = i['name']
		dictionary['parent'] = i['parent']
		dictionary['ActualValue'] = i['ActualValue']
		dictionary['description'] = i['description']
		dictionary['Time'] = i['Time']
		dictionary['AnalyseTool'] = i['AnalyseTool']
		dictionary['VisibleLevel'] = i['VisibleLevel']
		dictionary['HighAlertValue'] = i['HighAlertValue']
		dictionary['AlDescription'] = i['AlDescription']
		dictionary['AlTime'] = i['AlTime']
		dictionary['Tid'] = i['Tid']
		new_a.append(dictionary)


	tree = []
	list_ind = []
	for i in new_a:
	    ind = new_a.index(i)
	    i['Id'] = ind
	    list_ind.append(i)

	mappedarr = {}
	for i in list_ind:
	    Id  = i['Id']
	    if Id not in mappedarr.keys():
	        mappedarr[Id] = i
	        mappedarr[Id]['children'] = []

	    
	for i in mappedarr.keys():
	    mappedelement = mappedarr[i]

	    if mappedelement['parent']:
	        parentid = mappedelement['parent']
	        (mappedarr[parentid]['children']).append(mappedelement)

	    else:
	        tree.append(mappedelement)    
	treeuniqueid = uuid.uuid4()	        
	# json_res = json.dumps(tree[1], indent = 4)
	# newString = json.replace("\'", '"')
	created_at = datetime.datetime.now()
	treeobject = Alerttree(treeuniqueid = treeuniqueid.hex,system_id = sysid,customer_id = cusid,tree = tree[1],created_at = created_at)	
	treeobject.save()


@api_view(['POST'])
def sysadd(request):
	if request.method == 'POST':
			cipher_suite = Fernet(key)
			formData = request.data.get("data") 
			envname = formData['environmentselected'] 
			envtype = formData['environmentTypeSelected'] 
			insttype = formData['instanceTypeSelected'] 
			systype= formData['systemTypeSelected'] 
			solution_id = formData['solutionselected']
			systemsinfo = formData['systemsinfo']
			customer_id = formData['customer_id']
			sub_by = formData['sub_by']
			
			solname = solutionname(solution_id)
			sysname = envtype + '_' + solname + '_' + systype

			for i in systemsinfo:
				system_id = uuid.uuid4()
				ostype = i['ostype']
				dbtype = i['dbtype']
				sid = i['sid']
				ip = i['ip']
				pwd = i['password']
				port = i['port']
				osversion = i['osversion']
				appuid = i['appuid']
				dbuid = i['dbuid']
				dbversion = i['dbversion']
				dbpassword = i['dbpassword']
				encryprtedpwd = cipher_suite.encrypt(str.encode(pwd))
				dbencryprtedpwd = cipher_suite.encrypt(str.encode(dbpassword))
				created_at = datetime.datetime.now()
				modified_at =datetime.datetime.now()	
				sywsdluniqueid = uuid.uuid4()
				sysname = sysname + '_' + sid
				wsdl = 'http://' + ip + ':' + port + '/?wsdl' 			
				instance = SystemsNew(sysuniqueid = system_id.hex,customer_id = customer_id,solution_id = solution_id,sysname = sysname,envname = envname,envtype = envtype,instancetype = insttype,systemtype = systype,ip = ip,sid = sid,ostype = ostype,osversion = osversion,dbtype = dbtype,dbversion = dbversion,appuid = appuid,dbuid = dbuid,apppassword = encryprtedpwd,dbpassword=dbencryprtedpwd,port = port,created_at= created_at,modified_at = modified_at,status = 1,sub_by=sub_by)
				instance.save()
				swsdl = Systemwsdl(sywsdluniqueid=sywsdluniqueid.hex,customer_id= customer_id,system_id=system_id.hex,syswsdlurl=wsdl,created_at=created_at,modified_at=modified_at,sub_by=sub_by)
				swsdl.save()
				users = i['guiuserinfo']
				instancelistsingle(ip,appuid,pwd,system_id.hex,customer_id,wsdl)
				currentalerts(wsdl,appuid,pwd,system_id.hex,customer_id)
				for j in users:
					usersuniqueid = uuid.uuid4()
					hostname = j['apphostname']
					uname = j['appusername']
					userpwd = j['apppassword']
					sysnr = j['appsysno']
					routerstring = j['approuterstring']
					euserpwd = cipher_suite.encrypt(str.encode(userpwd))
					userinfo = Applicationusers(usersuniqueid = usersuniqueid.hex,system_id = system_id,ip = hostname,username = uname,password=euserpwd,sysnr = sysnr,routerstring = routerstring,created_at = created_at,modified_at = modified_at,sub_by = sub_by)
					userinfo.save()


	return Response(request.data, status=status.HTTP_201_CREATED)								

@api_view(['POST'])
def customeradd(request):
	if request.method == 'POST':
		formData = request.data.get("formData") 
		companyname = formData['companyname']		
		contactname = formData['contactname']		
		email = formData['email']		
		companycontact = formData['companycontact']		
		pwd = formData['password']		
		address = formData['address']	
		hashAndSalt = bcrypt.hashpw(pwd.encode(), bcrypt.gensalt()) 
		fpwd = hashAndSalt.decode('utf8')
		created_at = datetime.datetime.now()
		modified_at = datetime.datetime.now()
		sub_by = email	
		cusuniqueid = uuid.uuid4() 
		customer = CustomerMang(cusuniqueid = cusuniqueid.hex,cuscomname = companyname,cuscontactname=contactname,cusmobnum=companycontact,cusaddress=address,cusemail=email,cuspassword=fpwd,isverified = 0,status=1,created_at=created_at,modified_at=modified_at,sub_by=sub_by)
		customer.save()
		return Response({"cusuniqueid":cusuniqueid.hex,"email":email}, status=status.HTTP_201_CREATED)						

@api_view(['POST'])
def login(request):
	if request.method == 'POST':
		formData = request.data.get("formData")
		email = formData["email"]
		pwd= formData["password"]

		hashpwd = Usermanagement.objects.filter(email = email).exclude(status =3).values('password')[0]['password']
		customer_id = Usermanagement.objects.filter(email = email).exclude(status =3).values('customer_id')[0]['customer_id']
		role_id = Usermanagement.objects.filter(email = email).exclude(status =3).values('role_id')[0]['role_id']
		# print(hashpwd)
		# print(pwd.encode('utf-8'))
		valid = bcrypt.checkpw(pwd.encode('utf-8'),hashpwd.encode('utf-8'))
		
		if valid:
			return Response({"message":"Success","email":email,"customerId":customer_id,"roleId" : role_id}, status=status.HTTP_200_OK)
		else:
			return Response({"message":"Failed","email":email}, status=status.HTTP_200_OK)

@api_view(['POST'])
def addsolution(request):
	if request.method == 'POST':
		customer_id = request.data.get('cid')		
		name = request.data.get('solutionname')
		created_at = datetime.datetime.now()
		modified_at = datetime.datetime.now()
		sub_by = request.data.get('sub_by')		
		solutionuniqueid = uuid.uuid4() 
		solution = Sapsolution(soluniqueid = solutionuniqueid.hex,customer_id = customer_id,solname=name,created_at=created_at,modified_at=modified_at,sub_by=sub_by)
		solution.save()
		return Response({"message":"Success"}, status=status.HTTP_200_OK)

@api_view(['POST'])
def addlandscape(request):
	if request.method == 'POST':
		customer_id = request.data.get('cid')
		solution_id = request.data.get('solutionid')		
		name = request.data.get('landscapename')
		created_at = datetime.datetime.now()
		modified_at = datetime.datetime.now()
		sub_by = request.data.get('sub_by')		
		landscapeuniqueid = uuid.uuid4() 
		landscape = Saplandscape(landuniqueid = landscapeuniqueid.hex,customer_id = customer_id,solution_id =solution_id, landname=name,created_at=created_at,modified_at=modified_at,sub_by=sub_by)
		landscape.save()
		return Response({"message":"Success"}, status=status.HTTP_200_OK)
#############################################################################################################
def healthcheckname(id):
	name = Healthcheck.objects.filter(healthcheckuniqueid = id).values('healthcheckname')[0]['healthcheckname']
	return name


@api_view(['GET', 'POST'])
def Gethealthchecklogs(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')

		systemId = request.data.get('sid')
		if systemId == None:
			metrics = Healthchecklogs.objects.filter(customer_id = customerId)
		else:	
			metrics = Healthchecklogs.objects.filter(customer_id = customerId).filter(system_id = systemId)
		sysname = "DC_CRM_DEV_SOD"
		serializer = HealthchecklogsSerializer(metrics, many = True)

		for i in serializer.data:
			i['sysname'] = sysname
			i['healthcheckname'] = healthcheckname(i['healthcheck_id'])
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)

@api_view(['GET', 'POST'])
def Gethealthcheckdata(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')
		healthcheck_id = request.data.get('hid')
		log_id = request.data.get('lid')
		
		modelname = Healthcheck.objects.filter(healthcheckuniqueid = healthcheck_id).values('modelname')[0]['modelname']
		serializername = Healthcheck.objects.filter(healthcheckuniqueid = healthcheck_id).values('serializername')[0]['serializername']
		updatedmodelname = eval(modelname)#eval for converting str to class. Not the right practice
		metrics = updatedmodelname.objects.filter(customer_id = customerId).filter(system_id = systemId).filter(log_id = log_id)
		updatedserializername = eval(serializername)
		serializer = updatedserializername(metrics, many = True)

		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)


@api_view(['GET', 'POST'])
def Getal(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Activelogs.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = ActivelogsSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)

@api_view(['GET', 'POST'])
def Getbp(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Bufferpool.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = BufferpoolSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getdbsnap(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Dbsnap.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DbsnapSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getdbi(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = DbInstances.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DbInstancesSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Gettsql(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Topsql.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = TopsqlSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getdbb(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Dbbackup.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DbbackupSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getdbls(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Dblocksnap.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DblocksnapSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getdbms(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Dbmanagersnap.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = DbmanagersnapSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Getrs(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Runstats.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = RunstatsSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				

@api_view(['GET', 'POST'])
def Gettbsp(request):
	if request.method == 'POST':
		customerId = request.data.get('cid')
		systemId = request.data.get('sid')


		metrics = Tablespc.objects.filter(customer_id = customerId).filter(system_id = systemId)

		serializer = TablespcSerializer(metrics, many = True)
		return Response(serializer.data, status=status.HTTP_200_OK)
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)				


def treeparser(l):

    for i in l:
        obj_list.append((i['name'],i['description'],i['Time']))

        treeparser(i['children'])   


@api_view(['GET', 'POST'])
def parse(request):
	obj_list = []
	def treeparser(l):

	    for i in l:
	        obj_list.append((i['name'],i['description'],i['Time']))

	        treeparser(i['children'])   

	if request.method == 'POST':
		obj = request.data.get('node')
		obj_list.append((obj['name'],obj['description'],obj['Time']))
		for i in obj['children']:

		    obj_list.append((i['name'],i['description'],i['Time']))
		    treeparser(i['children'])
		output = {"parsed_tree" : obj_list, "message" : "success" }    
		return Response(output, status = status.HTTP_200_OK)    
	else:
		return Response({"message":"Bad Request"}, status=status.HTTP_400_BAD_REQUEST)		
